"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _connectorRIPE = _interopRequireDefault(require("./connectors/connectorRIPE"));
var _connectorAFRINIC = _interopRequireDefault(require("./connectors/connectorAFRINIC"));
var _connectorLACNIC = _interopRequireDefault(require("./connectors/connectorLACNIC"));
var _connectorAPNIC = _interopRequireDefault(require("./connectors/connectorAPNIC"));
var _connectorARIN = _interopRequireDefault(require("./connectors/connectorARIN"));
var _batchPromises = _interopRequireDefault(require("batch-promises"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var WhoisParser = exports["default"] = /*#__PURE__*/_createClass(function WhoisParser(params) {
  var _this = this;
  _classCallCheck(this, WhoisParser);
  _defineProperty(this, "_getObjects", function (types, filterFunction, fields, forEachFunction) {
    fields = fields || [];
    var objects = [];
    return (0, _batchPromises["default"])(3, Object.keys(_this.connectors), function (connector) {
      return _this.connectors[connector].getObjects(types, filterFunction, fields, forEachFunction).then(function (results) {
        return objects.concat(results.flat());
      })["catch"](console.log);
    });
  });
  _defineProperty(this, "getObjects", function (types, filterFunction, fields) {
    return _this._getObjects(types, filterFunction, fields, null);
  });
  _defineProperty(this, "forEachObject", function (types, filterFunction, fields, forEachFunction) {
    return _this._getObjects(types, filterFunction, fields, forEachFunction).then(function () {
      return null;
    });
  });
  this.params = params || {
    userAgent: "bulk-whois-parser"
  };
  this.cacheDir = this.params.cacheDir || ".cache/";
  this.connectors = {};
  var connectors = {
    "ripe": _connectorRIPE["default"],
    "afrinic": _connectorAFRINIC["default"],
    "apnic": _connectorAPNIC["default"],
    "arin": _connectorARIN["default"],
    "lacnic": _connectorLACNIC["default"]
  };
  if (this.params.repos) {
    var _iterator = _createForOfIteratorHelper(this.params.repos),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var repo = _step.value;
        this.connectors[repo] = new connectors[repo](this.params);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  } else {
    for (var _repo in connectors) {
      this.connectors[_repo] = new connectors[_repo](this.params);
    }
  }
});